#!/bin/sh

ERR_LOG_NAME='/var/log/ERR_N8100-1018_patch02-0.log'
CON_LOG_NAME='/var/log/CONFIG_N8100-1018_patch02-0.log'

#
# N8100-1018_UpdateModule-2.0 Update check
#
if [ -s /var/log/N8100-1018_patch02-0.log ] ;
then
	/bin/echo "Update stopped. N8100-1018_UpdateModule-2.0 has been installed."
	/bin/echo "`/bin/date -I` Update stopped. N8100-1018_UpdateModule-2.0 has been installed."  >> $ERR_LOG_NAME
	exit
fi

/bin/echo "N8100-1018_UpdateModule-2.0 Update Start"
/bin/echo "`/bin/date -I` N8100-1018_UpdateModule-2.0 Update Start" >> $ERR_LOG_NAME

#
# iplb4d update arrangements command script
#

# Watch & Mes stop

/etc/rc.d/init.d/iplb4md stop
sleep 2
/etc/rc.d/init.d/iplb4wd stop
sleep 2

# Wait 10 second
count=1
while [ $count -le 3 ];
do
        sleep 3
        /bin/echo -n .
        count=`expr $count + 1`
done

sleep 3
/bin/echo .

# Main Process stop
/etc/rc.d/init.d/iplb4d stop
sleep 2
/etc/rc.d/init.d/cntsd stop
sleep 2

#
# ipvs modules unload
#

/sbin/lsmod > ./lsmod.txt

/bin/cat <<"EOF" > ./test.pl
#/usr/bin/perl

while(<>) {
    if( /^ip_vs/ ) {
        s/(\w+)\b/$1/;
        system "/sbin/rmmod", $1;
    }
}

EOF

/bin/chmod 0755 ./test.pl

/usr/bin/perl ./test.pl ./lsmod.txt


#
# ktcpvs modules unload
#
    
/sbin/lsmod > ./lsmod.txt
    
/bin/cat <<"EOF" > ./test.pl
#/usr/bin/perl

while(<>) {
    if( /^tcp_vs/ ) {
        s/(\w+)\b/$1/;
        system "/sbin/rmmod", $1;
    }
}

EOF
    
/bin/chmod 0755 ./test.pl
    
/sbin/tcpvsadm -c
sleep 2
    
if [ -e /proc/sys/net/ktcpvs/unload ] ;
then
	echo "1" > /proc/sys/net/ktcpvs/unload
	/usr/bin/perl ./test.pl ./lsmod.txt
	sleep 2
	/sbin/rmmod ktcpvs
 	sleep 2
fi


#
# Config File Modify
#
	if /bin/cp -fp ./config_program/config_ReadFile.pl /tmp/. >> $CON_LOG_NAME 2>&1;
	then
		/bin/echo "config_ReadFile.pl copy : O.K." >> $CON_LOG_NAME
	else
                /bin/echo "ERROR(CONFIG_READFILE_COPY):Iplb Update stopped. "
                /bin/echo "config_ReadFile.pl copy : ERR" >> $CON_LOG_NAME
                exit
        fi

	sleep 2

	if /usr/bin/perl ./config_program/hosts_config.pl >> $CON_LOG_NAME 2>&1;
	then
        	/bin/echo "hosts_config : O.K." >> $CON_LOG_NAME
	else
        	/bin/echo "ERROR(CONFIG1):Iplb Update stopped. "
        	/bin/echo "hosts_config : ERR" >> $CON_LOG_NAME
        	exit
	fi

	sleep 2

	if /bin/cp -fp ./config_program/account.pl /opt/nec/wbmc/domain/adm/account/account.pl >> $CON_LOG_NAME 2>&1; 
	then
		/bin/echo "account.pl copy : O.K." >> $CON_LOG_NAME
	else
		/bin/echo "ERROR(ACCOUNT_COPY):Iplb Update stopped. "
		/bin/echo "account.pl copy : ERR" >> $CON_LOG_NAME
		exit
        fi
	
	sleep 2

        if /usr/bin/perl ./config_program/contents_users_config.pl >> $CON_LOG_NAME 2>&1;
	then
        	/bin/echo "contents_users_config : O.K." >> $CON_LOG_NAME
        else
                /bin/echo "ERROR(CONFIG3):Iplb Update stopped. "
                /bin/echo "contents_users_config : ERR" >> $CON_LOG_NAME
                exit
	fi

	/bin/echo "Config File Modify Finish!!" >> $CON_LOG_NAME


#
# wbmcap update
# 
if /bin/rpm -Uvh --nodeps --force  ./N8100-1018_UpdateModule-2.0/wbmcap-6.1-3.noarch.rpm >> $ERR_LOG_NAME  2>&1;
then
	/bin/echo "Wbmcap update finish!"
	/bin/echo "Wbmcap update finish!" >> $ERR_LOG_NAME  2>&1
	
else
	/bin/echo "ERROR:Wbmcap update stopped. Code1"
	/bin/echo "ERROR:Wbmcap update stopped. Code1" >> $ERR_LOG_NAME
	/bin/rpm -qa | /bin/grep wbmcap >> $ERR_LOG_NAME  2>&1
  	exit

fi

sleep 3

#
# iplb update
#

if /bin/rpm -Uvh --nodeps --force ./N8100-1018_UpdateModule-2.0/iplb4-3.2.0-2.i386.rpm >> $ERR_LOG_NAME  2>&1;
then
	/bin/echo "Iplb update finish!"
	/bin/echo "Iplb update finish!" >> $ERR_LOG_NAME
else
	/bin/echo "ERROR:Iplb update stopped. Code1"
	/bin/echo "ERROR:Iplb update stopped. Code1" >> $ERR_LOG_NAME
	/bin/rpm -qa | /bin/grep iplb >> $ERR_LOG_NAME  2>&1
	exit
fi

sleep 3

#
# ktcpvs update
#

if /bin/cp -fp ./N8100-1018_UpdateModule-2.0/ktcpvs/* /usr/lib/ktcpvs/. >> $ERR_LOG_NAME 2>&1;
then
	/bin/echo "ktcpvs update finish!"
        /bin/echo "ktcpvs update finish!" >> $ERR_LOG_NAME
else
	/bin/echo "ERROR:ktcpvs update stopped. Code1"
        /bin/echo "ERROR:ktcpvs update stopped. Code1" >> $ERR_LOG_NAME
        exit
fi

sleep 3

#
# logrotate change
#
cat << EOM > ./change_logrotate.pl
#!/bin/perl

while(<>) {
        if( /iplb4_wbmc.log/ ) {
                print "see iplb4_wbmc.log\n";
                exit;
        }
}
system("echo \"/var/log/iplb4/iplb4_wbmc.log {\n    missingok\n    prostrotate\n    endscript\n    rotate 5\n    monthly\n}\n\" >> /etc/logrotate.d/iplb4d");

print "finish!!\n";
EOM

perl ./change_logrotate.pl /etc/logrotate.d/iplb4d

rm -f ./change_logrotate.pl
echo "logrotate(iplb4d) file change finish!!"

#
# wbmchttpd.conf edit command script
#
perl -pne 's/^(Header\s+Set\s+Pragma\s+\"no-cache\")/#$1/' /etc/opt/nec/wbmchttpd/conf/wbmchttpd.conf > /tmp/wbmchttpd.conf.chg
mv /tmp/wbmchttpd.conf.chg /etc/opt/nec/wbmchttpd/conf/wbmchttpd.conf

/etc/rc.d/init.d/wbmchttpd restart

#
# End 
#
/bin/rm -rf ./N8100-1018_UpdateModule-2.0
/bin/rm -rf ./config_program
/bin/rm -rf ./N8100-1018_UpdateModule-2.0.tar.gz
/bin/rm -rf ./test.pl
/bin/rm -rf ./lsmod.txt
/bin/rm -rf /tmp/config_ReadFile.pl

#
# update timestamp 
#

/bin/date >> /var/log/N8100-1018_patch02-0.log
/bin/echo "N8100-1018_UpdateModule-2.0 install" >> /var/log/N8100-1018_patch01-0.log


/bin/echo "Express5800/LB300c UpdateModule-2.0 install finish!!"
